#!/bin/bash
# Script to generate DSA and RSA keys to use with ProFTPd with SFTP.
# Copyright (C) 2015  Manuel Silva (msilva@portolinux.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [[ -z $1 ]]; then
  echo "Requires a directory where to store SSH keys"
  exit 127
fi

mkdir -p "$1"
for alg in 'dsa' 'rsa'; do
  fullpath="$1/ssh_${alg}_key"
  dirname=$(dirname "$fullpath")
  filename=$(basename "$fullpath")
  fullpath="${dirname}/${filename}"
  ssh-keygen -f "${fullpath}" -N '' -t $alg
  chmod 400 "${fullpath}"
done
