#!/bin/bash
# Script to convert system users into virtual users for ProFTPd file auth
# method keeping the same UID, GID, home directory and password.
# Copyright (C) 2015  Manuel Silva (msilva@portolinux.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [[ $UID -ne 0 ]]; then
  echo "Needs root to read /etc/shadow"
  exit 127
fi

username=$1

passwd_p1=$(grep $username /etc/shadow)
if [[ $? -gt 0 ]]; then
  echo "Failed to find $username in /etc/shadow"
  exit 128
fi
passwd_p1=$(echo "$passwd_p1" | cut -d : -f1-2)

passwd_p2=$(grep $username /etc/passwd)
if [[ $? -gt 0 ]]; then
  echo "Failed to find $username in /etc/passwd"
  exit 129
fi
passwd_p2=$(echo "$passwd_p2" | cut -d : -f 3-6)

echo "${passwd_p1}:${passwd_p2}:/bin/false"
